/*

	This program will output the sound when the mixer has nothing to play.

*/

#include <cstdio>
#include <unistd.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <string>
#include <cstdlib>
#include <csignal>
#include <ctime>

using namespace std;

static const string arvolause(void)
{
	static unsigned last = 0;
	static const char *laus[] =
	{
		"Numero, johon soititte, oli vr.",
		"Tavoittelemanne radio ei ole pll.",
		"Tarvittavat resurssit puuttuvat.",
		"Radio ei ole pll.",
		"Seuraavaksi horinaa. sfrgsamwmawrf eawth aw zfh zshgzsrgqtu larglha wrlhlahwr.",
		"Olkaa hyv ja odottakaa.",
		"Etsin musiikkia.",
		"Sekmentation faultt",
		"KRSSSH",
		"PAM",
		"Thn sopisi ehk taustamusiikki.",
		"Linjalla on jotain hirit.",
		"Radio ei ole kytss.",
		"Yrittk myhemmin uudelleen.",
		"Saavumme Tampereelle.",
		"Tm on suora lhetys Keravalta.",
		"epjrjestelmllistyttmttmyydellnskn.",
		"awrgwrhyawr",
		"lzsuopbuouwojhljzlhjb",
		"llwlhawrj zpupuiqpugwalhj ajwrhj",
		"zbpzupnu zpsrutqput ljzslfdgu oy",
		"iit aqjet jzsprug jqtu aweurhpu zosyrgiyaqiote awrhgphawrh",
		"apowurphuawrtjqe jawriuga wprgoaywrohyoaywrhawr uhzshdlkglzgqleuglguawrg",
		"Tss lis horinaa. bulq pip qpi k awrh larglha wrlhlahwr larglha wrlhlahwr larglha zuqput",
		"Apua, minut on lukittu tnne",
		"Onkohan minulle annettu vrt vuorosanat?",
		"Kukkuu",
		"Tm on typer."
	};
	const unsigned int max = (sizeof laus) / (sizeof(laus[0]));
	unsigned uusi = rand() % max;
	if(uusi == last)
		uusi = (uusi+1) % max;
	
	return laus[last = uusi];
}

static int childpid=-1;
static void killer(int)
{
	if(childpid >= 0)
	{
		kill(childpid, SIGTERM);
		usleep(200000);
		kill(childpid, SIGKILL);
	}
	exit(-1);
}

static bool isfatal(int sig)
{
	return sig == SIGPIPE;
}

int main(void)
{
	setreuid(65535, 65535);
	setregid(65535, 65535);
	
	signal(SIGPIPE, killer);
	signal(SIGINT, killer),
	srand(time(NULL));
    for(;;)
    {
    	char Params[256];
    	sprintf(Params,
    	    "say -x %u -S %.1f -c %u -r 8000 -a -l - '",
    	    900 + rand()%600,
    	    1.9 - (drand48() * drand48()) * 0.9,
    	    4 - rand()%2);
    	
   		string lause = Params + arvolause() + "'|resample mr8000 ''";
   		
    	int childpid = fork();
    	if(!childpid)
    	{
    		
    	#if 0
    		int n = open("/dev/null", O_WRONLY);
    		dup2(n, 2);
    		close(n);
    	#endif
    	
    	#if 1
    		execlp("hum",
    		       "hum",
    		       NULL);
    	#endif
    	
    	#if 0    		
    		execlp("mikmod",
    		       "mikmod",
    		       "-sir",
    		       "-d2",
    		       "/dosc/mod/nes/mman2_f.s3m",
    		       NULL);
    	#endif
    	#if 0
    		execlp("/bin/sh",
    		       "sh",
    		       "-c",
    		       lause.c_str(),
    		       NULL);
    	#endif
    	#if 0
			execlp("mpg123",
	    		   "mpg123",
	    		   "-s",
	    		   "-q",
	    		   "/mp3/Bisqwit/Elecman-Loop.mp3",
	    		   NULL);
	    #endif
	    #if 0
	    	execlp("mpg123",
	    	       "mpg123",
	    	       "-f20000",
	    	       "-k7734",
	    	       "-n610",
	    	       "-q",
	    	       "-s",
	    	       "/mp3/FinalFantasy-VII-OS-NobuoUematsu/Sephiroth-Final-Battle.mp3",
	    	       NULL);
	    #endif
	    #if 1
	    	execlp("mpg123",
	    	       "mpg123",
	    	       "-k1550",
	    	       "-n221",
	    	       "-q",
	    	       "-s",
	    	       "/mp3/WeirdAlYankovic/PolkaYourEyesOut.mp3",
	    	       NULL);
	    #endif
	    	_exit(0);
	    }
	    int pp;
	    wait(&pp);
	    if((WIFSIGNALED(pp) && isfatal(WTERMSIG(pp))
	    || (WIFEXITED(pp) && WEXITSTATUS(pp)==255)))
	    {
	    	return 0;
	    }
	    
	    childpid=-1;
	}
	return 0;
}
