<?php
//TITLE=Audio stream mixing tools

$title = 'Audio stream mixing tools';
$progname = 'streamixer';

function usagetext($prog)
{
  exec($prog.' --help 2>&1', $kk);
  $k='';foreach($kk as $s)$k.="$s\n";
  return $k;
}

$text = array(
   '1. Program list' => "

This package contains several audio stream tool programs
for little-endian systems.
<p>
Note that none of these programs (except <a href=\"#ecat\">ecat</a>)
talk directly with a soundcard. They only handle raw audio streams.

", 'mixer:1.1. mixer' => "

A stream mixing server. It accepts <a href=\"#mixwrite\">mixwrite</a>
and <a href=\"#mixmon\">mixmon</a> -connections.
<br>Provides a server for audio stream mixing.<br>
Meant to be a replacement for esd, with
much more features and much less cpu usage.

", 'mixmon:1.1. mixmon' => "

Monitors the mixer over a tcp connection,
reading whatever is being mixed to it.

", 'mixwrite:1.1. mixwrite' => "

Sends stream to the mixer over a tcp connection.

", 'resample:1.1. resample' => "

Resamples audio stream from one format to another format,
trying to not produce resampling artifacts.

<pre class=smallerpre>".htmlspecialchars(usagetext('resample'))."</pre>

", 'mixeridle:1.1. mixeridle' => "

Generates idle stream for the mixer, if there
are readers for the mixer but no writers.<br>
Actually has been hardcoded to play something nasty...
you should probably customize it :)<br>
<em>Note that if mixeridle fails to produce
anything, mixer will hang waiting.</em>

", 'ecat:1.1. ecat' => "

Outputs its stdin to the audio device (/dev/dsp for example)
with the specified bitness, stereo and sampling rate. Useful
backend to the mixer (with mixmon).<br>
This finally obsoletes my previous hack to do the same:
<pre class=smallerpre>... | <a href=\"http://www.sulaco.org/mp3/\"
>lame</a> -rxdh -b 128 - - | <a href=\"http://www.mpg123.org/\"
>mpg123</a> -q -</pre>
<p>
Here's a nice experiment to lower music pitch:
<pre class=smallerpre
>\$ <a href=\"http://bisqwit.iki.fi/get/src/spcplay-1.39bisq.tar.gz\"
>spcplay</a> -r60000 -uao- ff5-world2.spc |ecat 
File: <a href=\"http://bisqwit.iki.fi/get/kala/spc/ff5/ff5-world2.spc\"
>ff5-world2.spc</a>
Song: Unknown Lands                        Game: Final Fantasy V                 
Comments: http://members.xoom.com/oksam_ff Author: Nobuo Uematsu, Squaresoft       
Dumper: AtLaS              Playtime: 0   Fadetime: 0   Emulator: Unknown (102)
Rate 70     Volume 100  12345678</pre>

And this plays two songs at the same time:
<pre class=smallerpre
>\$ mixer &
\$ mixmon|ecat &
\$ mpg123 -s 01-Trust.mp3 |mixwrite &
\$ mpg123 -s 14-DesperateFeelings.mp3 |mixwrite &</pre>
(total CPU load being around 25% with my 233 MHz laptop)
<p>
Hint: Sound card usually can't play arbitrary sampling rates.
Use <a href=\"#resample\">resample</a> together with ecat to help.
<pre class=smallerpre
>\$ <a href=\"http://www.mpg123.org/\">mpg123</a> -r34500 -qvvs /mp3/OwaranaiNatsu.mp3 |ecat
Using memory mapped IO for this stream.
No supported rate found!

\$ mpg123 -qvvs /mp3/OwaranaiNatsu.mp3 |resample r44100 r34500 -f lanczos|ecat
Using memory mapped IO for this stream.
Audio: 1:1 conversion, rate: 44100, encoding: signed 16 bit, channels: 2
128 kb/s - frame#  4215 [ 6300], Time: 01:50.10 [02:44.57], </pre>
This example upsampled 44.1 kHz stream a happy 28% and played it with 44.1 kHz sampling rate,
still not damaging the sound hearably. Try \"none\" as the filter (that's what most programs do)
and you really do hear the difference. Try \"linear\" as the filter (that's what most programs
do when they are \"interpolating\") and it's still not as good as it is when more modern filters
are being used.

", 'mixerscript:1.1. mixerscript' => "

Mixes 16-bit stereo streams together in a predefined exact way.<br>
Useful if you want to mix some wavs together.<br>
A time offset may be defined.

<pre class=smallerpre>".htmlspecialchars(usagetext('mixerscript'))."</pre>

", '1. Requirements' => "

GNU make is probably required.<br>

", '1. Installation' => "

<pre class=smallerpre
>\$ make
\$ su
# make install</pre>

If you do not want to install
<a href=\"http://oktober.stc.cx/source/libargh.html\">libargh</a>
(included in the archive), do not use \"make install\" and edit
Makefile and enable the STATIC linking instead of DYNAMIC.

", '1. Copying' => "

These tools have been written by Joel Yliluoma, a.k.a.
<a href=\"http://bisqwit.iki.fi/\">Bisqwit</a>,<br>
and are distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).

<p>
Note: If you want to look at earlier versions, have a look at
<a href=\"http://oktober.stc.cx/source/wavegenerator.html\">wavegenerator</a>.
The earlier versions were together in a same archive.

");
include '/WWW/progdesc.php';
