#include "soundtypes.h"

#ifndef GCC2
#define inbufsize 0x800
#define leapstep 0x400
#define newsize (inbufsize-leapstep)
#endif

class Stream
{
#ifdef GCC2
private:
	static const int inbufsize = 0x800;
	static const int leapstep  = 0x400;
	static const int newsize   = inbufsize-leapstep;
#endif
private:
	bool bit16;
	bool stereo;
	unsigned herz;
	
private:
	/* Reads 16-bit mono entries */
	static unsigned read16(stent *dest, unsigned count);
	/* Reads 8-bit stereo entries */
	static unsigned readste(stent *dest, unsigned count);
	/* Reads 8-bit mono entries */
	static unsigned read8(stent *dest, unsigned count);
	/* Writes 16-bit mono entries */
	static void write16(const stent *src, unsigned count);
	/* Writes 8-bit stereo entries */
	static void writeste(const stent *src, unsigned count);
	/* Writes 8-bit mono entries */
	static void write8(const stent *src, unsigned count);
	/* 16-bit stereo reading/writing does not need conversion. */

	int basepos; /* mit ei en saa takaisin */
	stent inent[inbufsize];
	
public:
	Stream(const char *settings);
	
	inline const unsigned rate() const { return herz; }
	
	const stent &operator[] (int index);
	
	inline void shift(int amount) { basepos -= amount; }
	
	unsigned Read(stent *dest, unsigned count) const;
    void Write(const stent *dest, unsigned count) const;
    
    void Flush() const;
};
